package com.github.roschlau.adventofcode.core.solvers.y2022

import com.github.roschlau.adventofcode.core.args
import kotlinx.coroutines.runBlocking
import org.junit.jupiter.api.Assertions
import org.junit.jupiter.params.ParameterizedTest
import org.junit.jupiter.params.provider.MethodSource

class Day2Test {

    @ParameterizedTest(name = "{0} -> {1}")
    @MethodSource("part1Args")
    fun `part 1`(input: String, solution: String) = runBlocking {
        Assertions.assertEquals(solution, Day2.solvePart1(input))
    }

    @ParameterizedTest(name = "{0} -> {1}")
    @MethodSource("part2Args")
    fun `part 2`(input: String, solution: String) = runBlocking {
        Assertions.assertEquals(solution, Day2.solvePart2(input))
    }

    @Suppress("unused")
    companion object {
        @JvmStatic
        fun part1Args() = args(
            testInput to "15",
            input to "12679",
        )

        @JvmStatic
        fun part2Args() = args(
            testInput to "12",
            input to "14470",
        )
    }
}

private val testInput = """
    A Y
    B X
    C Z
""".trimIndent()

private val input = """
    C X
    A Y
    C Z
    B Y
    C Z
    A Z
    B Y
    C Z
    C Z
    B X
    A X
    A Z
    C Z
    C X
    A Z
    A Z
    C Z
    A X
    A Z
    A Z
    A Z
    A Z
    A Z
    C Z
    A Z
    C X
    C Z
    A Z
    A Z
    B Y
    C Z
    B X
    B X
    A Z
    C Z
    A X
    A X
    B Y
    B Z
    B Y
    A Z
    C Z
    C X
    C Z
    C Z
    C Z
    C Z
    A Z
    A Z
    A Y
    A Y
    C Z
    A X
    C Y
    A Z
    B Y
    C Z
    C Z
    B Y
    C Z
    C Z
    C Z
    A Z
    A Z
    B Y
    C Z
    A Z
    C Z
    C Z
    A Z
    B X
    C Z
    A X
    A X
    A Y
    C X
    A Y
    B X
    A Z
    A Z
    C Z
    A Z
    A Y
    C X
    A X
    B Y
    A Z
    A Y
    C Z
    C Y
    A X
    B Z
    B Y
    A Y
    C Z
    C Z
    C Z
    B Y
    A Z
    C Z
    A Y
    C Z
    A X
    C Z
    C Z
    A Z
    A X
    C X
    C X
    A X
    A X
    A Y
    A Z
    C Z
    A X
    A Z
    B Y
    A Y
    A Z
    C Z
    B Y
    A Z
    C Z
    A Z
    A X
    A Z
    B Y
    C Z
    C Z
    C Z
    C X
    A X
    C Z
    A X
    B Y
    C X
    C Z
    B Y
    B Y
    B X
    C Z
    B Y
    C Z
    C Z
    C Z
    A Z
    C Z
    C Z
    B Y
    C Z
    B Z
    C Z
    C Z
    A X
    C Z
    C Z
    A Z
    C Z
    C X
    C Z
    A Z
    A Z
    A X
    B X
    C Y
    A X
    A Y
    C Y
    C Z
    A Z
    A X
    C X
    C Z
    A X
    B Y
    C Z
    A X
    A X
    C Z
    B Y
    C Z
    A Y
    A Z
    B Y
    A Y
    A X
    C X
    A Z
    C Z
    B Y
    C Z
    C Z
    C Z
    C Z
    A Z
    C Y
    C Z
    A Y
    A X
    A Z
    A Z
    A Z
    C Z
    C Z
    A Z
    C Z
    A Z
    C Z
    A Z
    C Z
    A X
    B Y
    C Z
    C Z
    C X
    B X
    A Z
    C Z
    A Y
    C Z
    B Y
    A Z
    C Y
    C Z
    C Y
    C Z
    B Y
    A Y
    A Z
    C Z
    C X
    C Z
    A Z
    A Z
    A Z
    A Z
    A Z
    C Z
    C X
    A X
    C Z
    A X
    A Z
    A Z
    A Z
    A Z
    A Z
    B Y
    C Z
    C Z
    A Z
    C Z
    C Z
    C Z
    A Z
    C Z
    C Z
    B Y
    C Z
    A Z
    A Y
    C Y
    B Y
    A Z
    A X
    A Y
    C X
    B Y
    C Z
    C X
    C Z
    A Z
    B Y
    C Z
    C X
    C Z
    A Y
    B Z
    C Z
    C Z
    C Z
    A X
    B Y
    C Z
    C X
    B Y
    B Y
    C X
    A Z
    B Y
    C Z
    A X
    B Y
    C Z
    C Z
    A Z
    B Y
    B Y
    B Y
    A X
    C Z
    B Y
    B Y
    B Y
    A X
    A Z
    C Z
    C Z
    B Y
    A Z
    B Y
    B X
    A Z
    C X
    A Z
    C Z
    A Z
    C Y
    A X
    B Y
    C Z
    B Y
    C Y
    C X
    A Y
    C Z
    A Y
    C X
    A Z
    A Z
    A Z
    A Z
    C Z
    A Y
    B Y
    C Z
    C Z
    B Y
    C Z
    C Z
    C Z
    C Z
    C Z
    C Z
    A X
    C Z
    C Z
    C Z
    A X
    A Z
    A X
    A Z
    A X
    A X
    C Z
    A Z
    B Y
    C Z
    A Z
    C Y
    A Z
    B Y
    B Y
    C Z
    B Y
    B Y
    A Y
    B Y
    A X
    C Z
    A Y
    C Z
    A Z
    A Z
    A X
    A Z
    A X
    C Z
    B Y
    A Z
    A X
    C Z
    C Z
    C Z
    A Z
    A Z
    C X
    A Z
    A Y
    A X
    C Z
    A Y
    C Z
    B X
    C X
    A X
    A X
    C Z
    A Y
    C X
    A Z
    B X
    A Z
    A Z
    A Z
    A X
    A Y
    A Z
    C Z
    A X
    C Z
    A X
    A Z
    A Z
    B Y
    A Z
    C X
    C X
    C Z
    A Z
    C X
    A Z
    A Y
    C Z
    C Z
    B Y
    C Z
    C Z
    A Z
    A Y
    B X
    C X
    C Z
    A Z
    C Z
    A X
    A Z
    A Z
    B Y
    A Y
    A Z
    A Z
    A Z
    C Y
    B Y
    A Y
    C Z
    C Z
    C X
    B Y
    C Z
    C Z
    A Y
    A X
    C Z
    C Z
    C X
    A Z
    B X
    C Z
    B Y
    A Y
    C Z
    C Z
    B X
    A X
    A X
    C Z
    A X
    A X
    C Z
    A Z
    C Z
    A Z
    A Z
    C Z
    A Y
    C Z
    C Z
    C Z
    A Z
    C Z
    C Z
    A Y
    C Z
    C Z
    C Z
    C Z
    C Z
    A Z
    C Z
    B Y
    A Z
    C Z
    C X
    A X
    C Z
    B Y
    A Z
    A X
    B Y
    C Z
    C Z
    C Z
    A X
    C Z
    A Z
    A Y
    A Y
    A Z
    A Z
    A Y
    B Y
    A Z
    C Z
    B Y
    C Z
    A Z
    C Z
    B Y
    B Z
    A X
    C Z
    A Y
    A Y
    A Z
    A X
    C Z
    C Z
    C Z
    C Z
    C Z
    A Z
    C Z
    A Z
    A Y
    A Z
    C X
    A Z
    C Y
    B Z
    C X
    A Z
    A X
    A X
    B Y
    C X
    C Z
    B Y
    A Z
    C Z
    C Z
    A Z
    C Z
    A Z
    C X
    C Y
    C Z
    A X
    C Y
    C Z
    A Z
    A Z
    C Z
    C Z
    A Y
    C Z
    C Z
    B Z
    C X
    A X
    A Z
    C Z
    A Y
    C Z
    C Z
    A X
    A Z
    A X
    A Y
    A Y
    A Y
    C Z
    B Y
    C Z
    A X
    C Y
    C Z
    B Y
    A X
    C Z
    A Z
    A Z
    B Y
    C Y
    A Y
    C Y
    A Z
    C Z
    A Z
    C Z
    C Z
    A Z
    A Z
    C Z
    A Z
    C Z
    A Y
    C Z
    C X
    C Z
    C Z
    C Z
    C Z
    A X
    B Z
    B X
    B Y
    B Y
    C Z
    A X
    A X
    B Y
    A Z
    A X
    C Z
    A X
    C X
    A Y
    A X
    C Z
    C Z
    C Z
    C Z
    C Z
    A X
    C Z
    B Y
    C X
    A X
    A Z
    A Z
    C Z
    C Z
    A Z
    A Z
    C Z
    A X
    A Z
    B Y
    C X
    A X
    A Y
    A Z
    C Z
    A Z
    A Z
    B Y
    A X
    B Y
    C X
    A Y
    B Y
    A Z
    C Z
    B Y
    A Z
    C Z
    C Z
    A Z
    C Z
    A Z
    C Z
    B Y
    A Z
    A Y
    C Z
    B Y
    A Z
    C Z
    C Z
    A Z
    A X
    A Z
    A Z
    C Y
    A Y
    C Z
    C Y
    C Z
    C Z
    B Y
    C Z
    C Y
    A Z
    C Z
    B Z
    C Y
    B Y
    C Y
    C Z
    A Y
    C Z
    A Z
    C Z
    A Y
    C Z
    C Z
    B Y
    B Y
    A Z
    C Z
    B Z
    C X
    B Y
    B Y
    C X
    B Y
    A X
    A X
    A Y
    A Z
    A X
    A X
    C Z
    C Z
    C Z
    C X
    C Z
    B Y
    B Z
    C Z
    A Z
    A Y
    A X
    B Y
    B X
    A X
    A Z
    C Z
    C Z
    A Z
    C Z
    A X
    B X
    B Z
    C Z
    B Y
    A Z
    A Z
    C X
    A X
    A Y
    C Z
    B Y
    C Z
    A Z
    A Z
    A Y
    C Z
    A Z
    A Z
    A Z
    C Z
    C Z
    C Z
    A X
    A X
    B X
    C Z
    A Y
    A Y
    A Y
    C Z
    A Z
    A X
    C Z
    A Z
    A Z
    A X
    C Z
    C Z
    C X
    A Z
    C Z
    C Z
    C Z
    A Z
    C Z
    A Z
    C X
    A Z
    C Z
    C Z
    A Y
    A Y
    C Z
    C Z
    C X
    A Z
    A Y
    C Z
    B Y
    C Z
    A Z
    C Z
    C X
    A Z
    A X
    B Y
    B Y
    C Z
    A Z
    A Z
    A Z
    B Z
    B Y
    C Z
    A Z
    C Z
    C Z
    A Z
    A Z
    A Z
    A X
    B Y
    C Z
    A X
    A Y
    A Z
    C Z
    A Z
    C Z
    C Z
    C X
    A Y
    C Z
    C Z
    C Z
    C Z
    B Y
    C Z
    C Z
    B Z
    C Z
    A X
    C Z
    C Z
    C Z
    A Z
    C Z
    C X
    A Y
    C Z
    A Z
    A Y
    A X
    B X
    B Y
    A Z
    A Z
    A X
    A Z
    C Z
    A Z
    A Z
    A Z
    A Z
    C Z
    A X
    A Z
    A Z
    A Y
    C Z
    B Y
    A X
    A X
    A X
    B Y
    C Z
    C Z
    C Z
    C Z
    B Y
    A X
    C Z
    B Y
    A Z
    C Z
    A Z
    B X
    B Y
    A X
    C Z
    C Z
    C X
    A Z
    A X
    C Z
    B Z
    A X
    A Z
    C Y
    A X
    C Z
    A X
    C Z
    C Z
    A Y
    A Z
    B Y
    A Z
    C X
    A Y
    C Z
    C Z
    A Y
    A Z
    C Z
    A Y
    A X
    A X
    A Y
    C Z
    C Z
    C Z
    A Z
    A Z
    C X
    A Z
    C Z
    A X
    C Z
    B Y
    C Y
    C Z
    A Z
    C Z
    A Z
    A Z
    C Z
    C Z
    A Z
    C Z
    C X
    A Z
    B Y
    A Y
    C Z
    C Z
    C Z
    C Z
    B Y
    A Z
    A Z
    A Z
    C Z
    A X
    C Z
    A Z
    C Y
    C X
    C Z
    C Z
    C Z
    A X
    B Y
    A X
    C Y
    C Y
    A Z
    A Z
    B Y
    A Y
    A Z
    A X
    C Z
    A Z
    C Z
    C Z
    A Z
    A X
    A Z
    A Z
    A Z
    C Z
    C Z
    A Z
    C Z
    A Z
    B Y
    A Z
    C Z
    A Y
    B Y
    B Y
    C Z
    A X
    A X
    C X
    B X
    B Y
    C Z
    B Y
    C Z
    C Z
    B Y
    C Z
    A Z
    A Y
    C Z
    C Z
    C Z
    B Y
    C Z
    C Y
    C Z
    A Z
    A Z
    B Y
    A X
    A X
    C Z
    B Y
    C X
    C Z
    A Z
    C Z
    C Z
    A X
    A Z
    A X
    C Z
    B Y
    C Z
    C Z
    C Z
    C Z
    A Z
    A Y
    C Z
    C X
    A Y
    A X
    A X
    A X
    C X
    A Z
    B Y
    B X
    C Z
    A Z
    C Z
    C Y
    A Z
    B Y
    A X
    A Z
    A Y
    C Z
    A Z
    A Z
    A X
    C Y
    A Z
    C Z
    A X
    B Y
    C Z
    A Y
    C Z
    C Z
    B Y
    A Y
    C Z
    A X
    A X
    A Y
    C X
    A X
    C X
    C X
    C Z
    A X
    C Z
    C Y
    C Z
    C X
    B Y
    C Z
    C Y
    A X
    C Z
    A X
    B Z
    A Y
    A Z
    C Z
    C Z
    C Z
    C Z
    A X
    C Z
    C Z
    C Z
    A Z
    B Y
    C Z
    C X
    B Y
    A Z
    C Z
    B Z
    C Z
    A Z
    C Z
    A Z
    B Y
    A Z
    C Z
    C Z
    C X
    A X
    A Z
    B Y
    C Z
    A X
    A Z
    A X
    B Y
    C Z
    A X
    C Z
    C Z
    C X
    C Z
    C Z
    C Z
    A X
    C Z
    B Z
    A Z
    B Y
    C Z
    B Z
    C X
    C X
    C Z
    C Z
    C Z
    B X
    C Z
    C Z
    C Z
    A Z
    B X
    A Y
    A Z
    C Z
    A Y
    A Z
    A X
    A Z
    A Y
    A X
    A Z
    A Z
    C Z
    C Z
    C Z
    A Y
    A X
    A Y
    B Y
    C Z
    B Y
    C Z
    C Z
    A X
    C X
    A Z
    C Z
    B Y
    A Z
    C Z
    B X
    A Y
    C Z
    C Z
    A Y
    C Z
    C Z
    A X
    C Y
    C Z
    A Z
    A Z
    A X
    A Y
    A Z
    C Z
    C Z
    A Z
    A X
    C Z
    A Y
    B X
    B X
    A Z
    A Z
    C Z
    A X
    A X
    C Z
    C X
    C Z
    C Z
    C Z
    C Z
    C X
    C X
    C Z
    A Y
    C Z
    C Z
    C Z
    A X
    B Y
    A Z
    C Z
    A Y
    A Y
    A Z
    C Z
    C Z
    A Z
    A Y
    A Z
    C Z
    C Z
    B X
    A X
    C Z
    C Z
    A Z
    C Z
    A Z
    C Z
    A Z
    A X
    A X
    A Z
    A X
    C Z
    C X
    A Z
    C X
    B Y
    A X
    A Z
    A Z
    C Z
    A Y
    A X
    C X
    A Z
    C X
    C Z
    A X
    C Z
    C Z
    B Y
    B Y
    C Z
    C X
    B Y
    A Z
    C Z
    C Z
    C Y
    C Z
    C Y
    C Z
    A X
    A Y
    B X
    C Z
    B Y
    A Y
    A X
    C X
    A Z
    A Y
    C Z
    B Y
    A Y
    C X
    A Z
    A Y
    A X
    C Z
    C Z
    C Z
    C Z
    A X
    A Y
    B Y
    C Z
    C Y
    A X
    A X
    A Z
    A Z
    A Z
    A Z
    A Z
    C Z
    A Z
    C Y
    A Y
    A Y
    B Y
    A Z
    A Z
    A Y
    C Z
    C Z
    A Z
    B Y
    B Y
    C Z
    B Y
    A X
    B Y
    A Y
    B Y
    C X
    B Y
    A X
    B Z
    C Z
    C Z
    C Z
    C Z
    A Y
    C Z
    A Z
    A Y
    B Y
    A X
    C Z
    B X
    C Z
    C Z
    C Z
    A Z
    A Z
    A Z
    A X
    C Y
    A Z
    B Y
    C Z
    C Z
    C Z
    A X
    B Y
    B Z
    C Z
    C Z
    C X
    A Z
    A X
    A X
    C Z
    A Z
    A X
    C Z
    A X
    A Z
    A Y
    C Z
    A Y
    C X
    A Z
    A X
    A Z
    C Z
    B Z
    A Y
    A X
    C X
    C Y
    B Y
    A X
    C Z
    C Z
    C Z
    C X
    C Z
    C X
    C Z
    C Z
    A Z
    A Z
    B Y
    A Y
    C X
    A X
    C Z
    A X
    C Z
    C Z
    B Y
    A Z
    A Y
    B Y
    A X
    C Z
    A Y
    A Z
    C Z
    B Y
    A X
    C Z
    B Y
    C Z
    A Z
    B Y
    C Y
    C X
    B Z
    A Z
    C Z
    A Z
    A Y
    C Z
    A Z
    C Z
    C Z
    C Z
    A Y
    C Z
    C Z
    A Z
    B Z
    C Z
    C Z
    C X
    A Z
    C X
    B X
    C X
    A Y
    C Z
    A Z
    A Y
    C X
    A X
    B Y
    C Y
    A Z
    A Z
    C Y
    C X
    A X
    A Z
    C Z
    A X
    A Z
    C X
    A X
    B X
    C Z
    C Z
    A X
    C X
    A Z
    A Z
    A Y
    C Z
    A X
    B Y
    C Z
    A Z
    C X
    A X
    C Z
    B Y
    A X
    B Y
    A Y
    C Y
    A Y
    C Y
    A X
    A Z
    C Z
    B Y
    C Z
    C Z
    B Y
    A X
    A Y
    B Y
    A X
    B X
    A Z
    C Z
    C X
    A Z
    A X
    C Z
    A Y
    C Z
    A Z
    A Z
    A Z
    A Y
    A Z
    B Y
    C Z
    C X
    C X
    C Z
    A Z
    A Z
    A X
    B Y
    C Z
    A Z
    C X
    B X
    C Z
    C Z
    A Z
    C Z
    C Z
    A Z
    B Y
    A X
    B X
    B Y
    A Z
    A Z
    A Z
    A Z
    A Y
    C Z
    C Z
    C Y
    B Y
    B Y
    B Y
    C Z
    C Z
    A X
    A Y
    C Z
    B Y
    B Z
    A X
    C Y
    C Z
    A X
    C Z
    C X
    A X
    C Z
    C Z
    A Y
    A X
    A Z
    A Z
    A Y
    C Z
    A Z
    C X
    B Z
    C Z
    B Y
    A Y
    C Z
    C Z
    A X
    C Z
    C X
    C X
    A Z
    A Y
    A Y
    B Y
    C X
    C Z
    A Z
    C X
    B Y
    A Z
    C Z
    A Y
    C Z
    A Z
    C Z
    A X
    C X
    A X
    A X
    A Y
    B Y
    C Z
    C Z
    A X
    C Z
    A Y
    A Z
    A Y
    B Y
    C Z
    A Z
    A Z
    A Z
    A Y
    C Y
    B X
    A X
    C Z
    A Y
    C Z
    A Y
    B Z
    A X
    C Z
    A Z
    C Z
    A Z
    A X
    C X
    A X
    A X
    A Z
    A Z
    C X
    B Y
    C Z
    C Y
    A Z
    A Z
    A Z
    A Z
    A Z
    A X
    B Z
    B Y
    A Y
    C Z
    A Z
    B Y
    A Z
    C Y
    A Y
    A X
    C Z
    A Z
    C Z
    C Z
    C Y
    A Z
    C Z
    A X
    A Z
    A Z
    B Y
    C Z
    C Z
    C Z
    C Z
    C Z
    C Z
    C Z
    B Y
    C Z
    C Z
    A Z
    C Z
    B Y
    C X
    C X
    C Z
    C Z
    C Z
    A Z
    B Y
    A X
    C Z
    B Y
    B Y
    C Z
    A X
    C Z
    C X
    C Z
    B Y
    B Y
    C Z
    A Z
    C Z
    C X
    B Y
    C Z
    A Z
    C Z
    C Z
    C Z
    C Z
    A Y
    C Y
    A Y
    C Z
    C Z
    A X
    A Z
    C Y
    C Z
    A X
    B Z
    C X
    C Z
    A Z
    C Z
    C X
    C Z
    C Y
    A X
    A Z
    A Y
    A X
    B X
    A Z
    A Y
    A Z
    B Y
    A Z
    B Y
    B Y
    C Z
    A Z
    C Z
    C Z
    A X
    A X
    C Z
    C Z
    C Z
    C Z
    C X
    A Y
    C Z
    C Z
    A Z
    A Y
    C Z
    A Z
    B Y
    C Z
    C Z
    C Z
    C Z
    A Z
    B Y
    B Z
    B Z
    A Z
    A Y
    A X
    C Z
    B X
    C Z
    B Y
    A X
    C Y
    A Y
    C Z
    C Z
    C X
    C Z
    C X
    C X
    A Z
    A X
    A Z
    C Z
    B X
    A Z
    C Z
    C Z
    A Z
    A Y
    C X
    A X
    C Z
    A X
    A Y
    A X
    A X
    A Z
    A Z
    C Z
    A Z
    A Z
    A Z
    B Y
    A Z
    C Z
    A Y
    C Z
    C Z
    A Z
    A Y
    A Y
    C X
    A X
    B Z
    A Z
    C Z
    A Z
    A Y
    A X
    B Y
    B Y
    A Y
    A Z
    A Z
    B X
    C X
    A Z
    C Z
    C X
    C Z
    C Z
    A X
    C Z
    C Z
    B Y
    A Z
    A Z
    A Y
    A Z
    A Y
    C Z
    C Z
    C Z
    C Z
    B Y
    B Y
    A Z
    C Z
    A Z
    A X
    C Z
    C Z
    A Y
    C Z
    B Y
    A X
    A X
    A Z
    C Z
    C Z
    C Y
    C Z
    A X
    C Z
    A Z
    C Z
    B Y
    A Z
    C Z
    B Y
    B Y
    C Z
    A Y
    C Z
    C Y
    A Z
    A X
    A X
    C Z
    A Y
    C Z
    A Z
    C Z
    A X
    A X
    A Z
    A Z
    C Z
    B Y
    C X
    A Y
    C Z
    C Z
    A X
    C Y
    A Y
    C Z
    C Y
    A Z
    B Z
    C Z
    A Z
    B Y
    B Y
    A Z
    C Z
    A X
    A Z
    C Z
    A Z
    C Z
    C Z
    B Y
    B Y
    A X
    B Y
    A Z
    C Z
    A Z
    A Z
    C Z
    A Y
    C Y
    C Z
    A X
    C Z
    A Z
    C Z
    C Z
    C Y
    C Z
    A Z
    C Z
    C Z
    B Y
    A Z
    C Z
    B X
    B Y
    A Y
    C Z
    A Z
    B Y
    A Z
    C Z
    C X
    C Z
    A Y
    A Y
    A Y
    B Y
    C Z
    A Z
    A Z
    C Z
    A Z
    C X
    A Z
    A Z
    A X
    A Z
    A Y
    C Z
    A Z
    C Z
    A Z
    A X
    C Z
    C X
    C Z
    C Z
    C Z
    C Z
    C Z
    B Y
    C Z
    A Y
    C Z
    B Y
    C X
    C Z
    C Z
    C Z
    B X
    A X
    C Z
    C Z
    C X
    C Z
    A Y
    C Z
    A Z
    A Z
    C Z
    C Z
    C Z
    A Z
    C Z
    A X
    A Z
    C Z
    A Z
    C Z
    A X
    C Z
    C Z
    C X
    A Z
    C Z
    C Z
    C Z
    C Z
    A X
    A Z
    A X
    C Z
    B Y
    C X
    B Y
    A Z
    C Z
    C Z
    A X
    A Z
    A Y
    A X
    A Z
    B Z
    B Y
    C Z
    C Z
    A Y
    C Z
    B Y
    C Z
    B X
    A Z
    C Z
    A Y
    A Z
    A Z
    B Y
    C X
    A Y
    C Z
    C Z
    C Z
    B Z
    B Y
    B X
    A X
    A X
    C Z
    C Z
    C X
    A Y
    C Z
    C Z
    C Y
    C Z
    A Z
    A X
    C Z
    B Y
    C Y
    A Z
    C Z
    A X
    C Z
    C Z
    A X
    A Y
    C Z
    A Y
    C Z
    A X
    C Z
    C Z
    C Z
    C Y
    B Y
    A Z
    C Z
    C X
    B Y
    A Y
    B Y
    C Z
    C Z
    A X
    C Z
    C Y
    A Z
    A X
    A Y
    C Z
    B X
    B Y
    C Z
    A Z
    B Y
    A Y
    C Z
    A X
    B Y
    A X
    C Z
    A Z
    C Z
    B Y
    A Z
    C X
    B Y
    A Y
    A Z
    A Z
    A X
    B Y
    B Y
    C Z
    A X
    C X
    A Z
    B Y
    A X
    B Y
    C Z
    A Z
    A Z
    C Z
    C Z
    A Z
    A X
    C Z
    B Y
    C Z
    C Z
    A Z
    C Z
    A Z
    B Z
    A Z
    C Z
    A Z
    A X
    A X
    A X
    A Y
    C Z
    C Y
    C Z
    C Y
    A X
    A X
    A Y
    C Z
    A Y
    C Z
    C Z
    C X
    B Y
    C Z
    C Z
    C Y
    B Y
    A X
    B X
    A Z
    C Z
    B Y
    A Z
    B Y
    A Y
    A Z
    B Z
    A Y
    A Y
    A X
    A Z
    A Y
    B Y
    C Z
    A X
    C Z
    B Y
    A Z
    C Z
    A Z
    A X
    B Y
    C Z
    A Z
    A Y
    C X
    B Y
    C Z
    C X
    A X
    C Z
    A Y
    C Z
    A X
    B Y
    C Y
    C Z
    A Y
    C Z
    A Z
    A Z
    A Z
    C Z
    C X
    B Y
    B Z
    C Z
    C Z
    C Z
    A Z
    C Z
    C Z
    A Z
    A Z
    B Y
    C Z
    A X
    A Y
    A X
    A Y
    C Z
    C Z
    B Y
    A X
    A Z
    A Z
    A Z
    C Z
    B Z
    C Y
    C Z
    B Y
    C Y
    C Z
    A Z
    C Z
    C X
    A Z
    A Z
    B Y
    A Z
    C Z
    A Y
    A X
    A Z
    A Y
    C Z
    C Z
    B Y
    B Y
    C Z
    C Z
    C Z
    C X
    A Z
    A Z
    C Z
    B Y
    C X
    B X
    C Z
    A Z
    C Y
    C Z
    C Z
    A X
    C Z
    C Z
    C Z
    A Z
    A Y
    C Z
    B Y
    C Z
    A X
    B X
    C X
    C Z
    A Z
    C Z
    A Z
    A Z
    C Z
    A Y
    A Z
    C Z
    A Z
    A Z
    A X
    C X
    C X
    A X
    C Z
    B Y
    B Y
    A Z
    A Z
    A X
    A Y
    B Y
    C Y
    A Z
    A Z
    C Z
    A X
    C Z
    A Y
    B Y
    C X
    A Y
    C Z
    C Z
    C Z
    A Z
    A Z
    C Y
    A X
    A X
    A X
    C X
    C X
    A X
    C Z
    A X
    B Y
    A Z
    A Z
    C Z
    A X
    A X
    A X
    C Z
    C Z
    C Z
    A Z
    C Z
    A Z
    A Z
    A X
    A Y
    A Y
    C Z
    B Y
    A Y
    A Z
    B Y
    B Y
    C Z
    B Y
    A Y
    C X
    A Z
    A Y
    C Z
    C Z
    A X
    A Z
    B Y
    C Z
    A Y
    A Z
    A Z
    A Z
    C Z
    A Z
    B Y
    C Z
    A Z
    A Z
    A Z
    A Y
    A X
    B Y
    A Z
    A Z
    B X
    A Y
    C Z
    C Z
    A Z
    A Z
    B Y
    A Y
    C Z
    A Z
    C Z
    C X
    C Z
    C X
    C Z
    B Y
    A Y
    C Z
    B Y
    A X
    B Y
    B Y
    A Z
    C Z
    A X
    A X
    C Z
    A X
    A Z
    C Z
    C Z
    B Y
    A Z
    C Z
    C Z
    C Z
    C X
    A Z
    A Z
    C Z
    A Z
    C Z
    C Z
    C X
    B Y
    A X
    A Z
    A X
    C Z
    A Y
    C Z
    C Z
    A X
    C Z
    B X
    A Z
    A Z
    C Z
    C Z
    A Y
    A X
    A Z
    A Z
    C Z
    C Z
    C Z
    C Z
    C Z
    B Y
    A Y
    A Z
    C Z
    C Z
    C Z
    C Z
    C Z
    C X
    A Y
    C X
    C Z
    C Z
    A X
    A Z
    A Z
    C Z
    B Z
    A Z
    B Y
    A Z
    C Z
    C Y
    A Z
    C Z
    C Z
    A X
    C Z
    C Z
    B Y
    A Y
    B Y
    C Z
    A Z
    B X
    C Z
    A Y
    B Y
    C Y
    A Z
    A Y
""".trimIndent()
